/* GCC */

#include <queue>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <sstream>
#include <fstream>
#include <map>
#include <iostream>
using namespace std;

#define NAME "crossing"

#define SZ 10000

typedef pair<int, int> link;

int n = 0;

map<int, int> names;

bool gr[SZ][SZ] = {};

int find_name(int i)
{
    for (map<int, int>::iterator j = names.begin(); j != names.end(); ++j)
        if (j->second == i)
            return j->first;
}

void read_gr()
{
    string line;
    istringstream parse;

    ifstream fin(NAME ".in");

    while (fin)
    {
        getline(fin, line);
        parse.clear();
        parse.str(line);
        int a, b;
        parse >> a >> b;
        if (names.find(a) == names.end())
            names[a] = n++;
        if (names.find(b) == names.end())
            names[b] = n++;
        gr[names[a]][names[b]] = true;
        gr[names[b]][names[a]] = true;
    }
    fin.close();
}


int bfs(int start)
{
    int k = 0;
    queue<int> q;
    bool visited[SZ] = {};
    q.push(start);
    while (!q.empty())
    {
        int curr = q.front();
        for (int i = 0; i < n; ++i)
            if (!visited[i] && gr[curr][i])
            {
                q.push(i);
                visited[i] = true;

            }
        visited[curr] = true;
        ++k;
        q.pop();
    }
    return k;
}


int main()
{
    read_gr();
    //cout << n << endl;

    //cout << bfs(6) << endl;

    vector <int> ans;

    for (int i = 0; i < n; ++i)
    {
        vector <int> del;
        for (int j = 0; j < n; ++j)
            if (gr[i][j])
            {
                gr[i][j] = false;
                del.push_back(j);
            }

        if ( bfs((i == 0?1:0)) != n)
            ans.push_back(find_name(i));
        for (int j = 0; j < del.size(); ++j)
            gr[i][del[j]] = true;
    }

    ofstream fout(NAME ".out");
    for (int i = 0; i < ans.size(); ++i)
        fout << ans[i] << ((i != ans.size() - 1)?" ":"\n");
    fout.close();

    return 0;
}
